#ifndef _CPU_GLUE_H
#define _CPU_GLUE_H

#include "globals.h"
#include <kos.h>

#define INT_NONE  0            /* No interrupt required      */
#define INT_IRQ   1            /* Standard IRQ interrupt     */
#define INT_NMI   2            /* Non-maskable interrupt     */
#define INT_QUIT  3            /* Exit the emulation         */ 

uint8 mem_read(uint32);
void mem_write(uint32, uint8);

uint32 bank_readaddress(register uint32);
uint8  bank_readbyte(register uint32);
void   bank_writebyte(register uint32, register uint8);
uint32 zp_address(register uint8);

extern uint8 reg_A, reg_P, reg_X, reg_Y, reg_S;
extern uint32 reg_PC;
extern uint8 *ram, *stack_page;


#endif
