#ifdef HAVE_CONFIG_H
#include "config.h"
#endif 

#ifdef HAVE_DC

#define DC_NO_PRINTF

#include "dc-glue.h"
#include <kos.h>

unsigned int code_cksum;
unsigned int total_frames;
unsigned int total_inst;
unsigned int total_cycles;

#define MAX_PROFILES 15
unsigned int profile_start_time[MAX_PROFILES];
unsigned int profile_total_time[MAX_PROFILES];
unsigned int profile_calls[MAX_PROFILES];

// FIXME
/*
// LOOKHERE Temporary see header file
int fwrite(void *stream, const char *fmt) {
   return 0;
}
int fputc(int c, void *stream) {
   return 0;
}
*/

void perror(const char *s) { fprintf(stderr,s); }

void exit(int ret) {  
//	int i = *((volatile unsigned int *)2);
	arch_exit();
}

unsigned int cksum_add32(void *addr, unsigned int len)
{
	int total = 0, i;
	uint8 *p = (uint8 *)addr;
	for (i = 0; i < len; i++) {
		total += *p++;
	}
	return total;
}

#ifdef PROFILE_ENABLE

int profile_start(unsigned int index) {
	/* ASSERT */
	if (index >= MAX_PROFILES) { return -1; }
	if (profile_start_time[index])
		printf("warning: profile %d re-entered\n", index);
	profile_calls[index]++;
	profile_start_time[index] = timer_count(2);
	return 0;
}

int profile_end(unsigned int index) {
	/* Timer counts down. */
	if (index >= MAX_PROFILES) { return -1; }
	profile_total_time[index] += profile_start_time[index] - timer_count(2);
	profile_start_time[index] = 0;
	return 0;
}

void profile_print() {
	int i;
	double sec;
	printf("Profiles:\n");
	for (i = 0; i < MAX_PROFILES; i++) {
		printf("%03d: calls %09d ticks %015d ", i, profile_calls[i], profile_total_time[i]);
		sec = (double)profile_total_time[i] / (double)TPS;
		printf("(%d.%02d sec)\n", (int)sec, (int)((sec-(int)sec)*100.0f));
	}

}

#endif

#endif
