#ifndef _HAVE_DC_GLUE_H
#define _HAVE_DC_GLUE_H

#include <kos.h>

#ifndef NULL
#error NULL not defined!
#define NULL ((void *)0x0)
#endif

// #define stderr NULL
#define eprintf(ARGS...) printf(ARGS)
#define CODE_SIZE 0x14000

#define TIMER32(o) ( *((volatile uint32*)(0xffd80000 + (o))) )
#define TCOR2 0x20
#define TCNT2 0x24

/* Pixel format for Palette RAM CTRL register. */
#define PAL_RAM_CTRL 0xa05f8108
#define PAL_FMT_ARGB1555 0
#define PAL_FMT_RGB565 1
#define PAL_FMT_ARGB4444 2
#define PAL_FMT_ARGB8888 3

/* We have to diddle with the poly header ourselves after
 * creation, since KOS doesn't support palette bank select. */
#define PAL_BANK_SHIFT_8BPP (25)
#define PAL_BANK_SHIFT_4BPP (21)
#define PAL_BANK_MASK_8BPP  (3 << PAL_BANK_SHIFT_8BPP)
#define PAL_BANK_MASK_4BPP (63 << PAL_BANK_SHIFT_4BPP)

#define PAL_BANK_TILE    0
#define PAL_BANK_SPRITE  1

/* TA scaling -- must set manually, otherwise TV is blurry at 320x240 */
#define SCALER_CFG 0xa05f80f4

void perror(const char *s);
void exit(int ret);
unsigned int cksum_add32(void *addr, unsigned int len);

extern unsigned int code_cksum;
extern unsigned int total_frames;
extern unsigned int total_inst;
extern unsigned int total_cycles;

#define TPS (50000000 / 64)

#undef PROFILE_ENABLE
#ifdef PROFILE_ENABLE
int profile_start(unsigned int index);
int profile_end(unsigned int index);
void profile_print();
#else
#define profile_start(ARGS...) ;
#define profile_end(ARGS...)   ;
#define profile_print(ARGS...) ;
#endif

#endif
